<template>
    <v-app id="inspire">
        <v-content>
            <v-row align="center" justify="center" no-gutters>
                <v-col cols="12" sm="12" md="5" lg="5">
                    <div class="login-section">
                        <img class="logo" src="~@/assets/icons/logo-beemenu.svg" alt="logo" />
                        <span class="welcome">BIENVENIDO DE VUELTA</span>
                        <h1 class="login">Logueate para continuar</h1>
                        <v-form ref="form">
                            <div class="input-size">
                                <v-text-field
                                    color="#feca38"
                                    v-model="email"
                                    :rules="emailRules"
                                    label="Email"
                                    name="login"
                                    append-icon="mdi-at"
                                    type="text"
                                    outlined
                                    rounded
                                    required
                                    class="mail"
                                ></v-text-field>
                            </div>
                            <div class="input-size">
                                <v-text-field
                                    color="#fdb947"
                                    v-model="pass"
                                    min="4"
                                    counter
                                    :append-icon="visiblePass ? 'mdi-lock-open-outline' : 'mdi-lock-outline'"
                                    @click:append="() => (visiblePass = !visiblePass)"
                                    id="password"
                                    label="Contraseña"
                                    name="password"
                                    :type="visiblePass ? 'text' : 'password'"
                                    @keyup.enter="loginUser(email, pass)"
                                    outlined
                                    rounded
                                    :rules="passwordRules"
                                    required
                                ></v-text-field>
                            </div>
                            <div class="login-btn">
                                <v-btn
                                    rounded
                                    width="100%"
                                    elevation="0"
                                    x-large
                                    color="#fdb947"
                                    @click="loginUser(email, pass)"
                                >
                                    <span v-if="!isLoading" class="enter">Entrar</span>
                                    <v-progress-circular
                                        v-else
                                        :size="20"
                                        color="black"
                                        indeterminate
                                    ></v-progress-circular>
                                </v-btn>
                            </div>

                            <div class="login-btn">
                                <GoogleButton></GoogleButton>
                            </div>

                            <div class="">
                                <v-alert class="rounded" v-show="error" type="error" style="margin-top: 20px;">{{
                                    error
                                }}</v-alert>
                            </div>
                        </v-form>

                        <span class="contact">
                            ¿Tienes problemas para acceder?
                            <a href="mailto:hola@BeeMenu.com">Contacto</a>
                        </span>
                    </div>
                </v-col>
                <v-col
                    class="d-none d-sm-none d-md-inline-flex d-lg-inline-flex"
                    style="height:100vh;"
                    cols="0"
                    xs="0"
                    sm="0"
                    md="7"
                    lg="7"
                >
                    <img src="~@/assets/imgs/log.png" />
                </v-col>
            </v-row>
        </v-content>
    </v-app>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import GoogleButton from '@/components/commons/ButtonGoogle.vue';
import { Action, namespace, State } from 'vuex-class';

const loginStore = namespace('LoginModule');

@Component({
    components: { GoogleButton }
})
export default class Login extends Vue {
    @loginStore.Action
    login!: (payload: { email: string; pass: string }) => Promise<void>;

    @Action('changeLoading')
    changeAction!: (payload: boolean) => Promise<void>;

    @State('isLoading')
    isLoading!: boolean;

    @loginStore.State
    error!: string;
    email = '';
    pass = '';
    visiblePass = false;

    emailRules = [
        (v: string) => !!v || 'E-mail es requerido',
        (v: string) => /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail no es valido'
    ];

    passwordRules = [(v: string) => !!v || 'Password is requerido'];

    async loginUser(email: string, pass: string): Promise<void> {
        await this.changeAction(true);
        await this.login({ email, pass });
    }
}
</script>

<style scoped>
.input-size {
    max-width: 500px;
}
.login-btn {
    margin: 15px 0 15px 0;
    max-width: 500px;
}
.v-text-field--outlined fieldset {
    border-radius: 30px;
}
.login-section {
    width: 100%;
    height: 100vh;
    padding: 50px;
    display: flex;
    flex-direction: column;
}
.login-section .logo {
    width: 200px;
    margin-bottom: 10vh;
}
.login-section .enter {
    font-size: 10px;
    font-weight: bolder;
}
.login-section .welcome {
    color: #72727f;
    font-size: 10px;
    font-weight: bolder;
    letter-spacing: 1px;
}
.login-section .contact {
    font-weight: bold;
    margin-left: 15px;
    text-align: center;
}
.login-section .contact a {
    color: #fdb947;
    text-decoration: none;
}
.cell-phone-container {
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: flex-start;
    align-items: flex-end;
}
.cell-phone-container img {
    width: 100%;
    height: 100%;
    max-width: 880px;
    max-height: 880px;
}

@media screen and (max-width: 700px) {
    .mail {
        margin-top: 40px;
    }
}
</style>
